#ifndef TARGET_SOLUTION


#pragma once

#include <glew.h>
#include "SceneObject.hpp"
#include "../Shader.h"


#define CUBE_VERTEX_COUNT 24
#define CUBE_INDEX_COUNT 36



namespace cgue {

	namespace scene {

		class Cube : public SceneObject {

		public:
			Cube(glm::mat4& matrix, Shader* shader);
			virtual ~Cube();

			virtual void update(double deltaT, std::string tastatur);
			virtual void draw();

		private:
			GLuint vao;
			GLuint positionBuffer, indexBuffer, uvBuffer, normalBuffer;
			Shader* shader;

			static const float positions[CUBE_VERTEX_COUNT * 3];
			static const float normals[CUBE_VERTEX_COUNT * 3];
			static const float uvs[CUBE_VERTEX_COUNT * 2];
			static const unsigned int indices[CUBE_INDEX_COUNT];
		};

	}

}
#endif