#ifndef TARGET_SOLUTION

#pragma once

#include <glew.h>
#include "SceneObject.hpp"
#include "../Shader.h"


#define HOUSE_LEFT_VERTEX_COUNT 24
#define HOUSE_LEFT_INDEX_COUNT 36

namespace cgue {

	namespace scene {

		class House_Left : public SceneObject {

		public:
			House_Left(glm::mat4& matrix, Shader* shader);
			virtual ~House_Left();

			virtual void update(double deltaT, std::string tastatur);
			virtual void draw();

		private:
			GLuint vao;
			GLuint positionBuffer3, indexBuffer3, uvBuffer3, normalBuffer3;
			Shader* shader;

			static const float positions[HOUSE_LEFT_VERTEX_COUNT * 3];
			static const float normals[HOUSE_LEFT_VERTEX_COUNT * 3];
			static const float uvs[HOUSE_LEFT_VERTEX_COUNT * 2];
			static const unsigned int indices[HOUSE_LEFT_INDEX_COUNT];
		};

	}

}
#endif