#ifndef TARGET_SOLUTION

#pragma once

#include <glew.h>
#include "SceneObject.hpp"
#include "../Shader.h"


#define STREET_VERTEX_COUNT 24
#define STREET_INDEX_COUNT 36

namespace cgue {

	namespace scene {

		class Street : public SceneObject {

		public:
			Street(glm::mat4& matrix, Shader* shader);
			virtual ~Street();

			virtual void update(double deltaT, std::string tastatur);
			virtual void draw();

		private:
			GLuint vao;
			GLuint positionBuffer2, indexBuffer2, uvBuffer2, normalBuffer2;
			Shader* shader;

			static const float positions[STREET_VERTEX_COUNT * 3];
			static const float normals[STREET_VERTEX_COUNT * 3];
			static const float uvs[STREET_VERTEX_COUNT * 2];
			static const unsigned int indices[STREET_INDEX_COUNT];
		};

	}

}
#endif