#version 330

layout(location = 6) in vec3 position;
layout(location = 7) in vec3 normal;
layout(location = 8) in vec2 uv;

out vec3 worldNormal;
out vec2 fUVs;
out vec4 ShadowCoord;

uniform mat4 modelMatrix;
uniform mat4 projectionMatrix;
uniform mat4 viewMatrix;
uniform mat4 DepthBiasMVP;
uniform vec3 lightPosition_worldspace;
uniform mat4 vpPrevious;
uniform sampler2D blurTexture;

out vec3 Position_worldspace;
out vec3 Normal_cameraspace;
out vec3 EyeDirection_cameraspace;
out vec3 LightDirection_cameraspace;
out mat4 vpInverse;

void main()
{

	fUVs = uv;
	worldNormal = (modelMatrix * vec4(normal, 0)).xyz;
	gl_Position = (projectionMatrix * viewMatrix * modelMatrix) * vec4(position, 1);
	
	vpInverse = inverse(projectionMatrix * viewMatrix);

	Position_worldspace = (modelMatrix * vec4(position, 1.0f)).xyz;

	vec3 position_modelspaceCamera = (viewMatrix * modelMatrix * vec4(position, 1.0f)).xyz;
    EyeDirection_cameraspace = vec3(0, 0, 0) - position_modelspaceCamera;
	//EyeDirection_cameraspace = vec3(0,0,0) - ( viewMatrix * modelMatrix * vec4(position,1)).xyz;

    vec3 lightPosition_worldspaceCamera = (viewMatrix * vec4(lightPosition_worldspace, 1.0f)).xyz;
    LightDirection_cameraspace = lightPosition_worldspaceCamera + EyeDirection_cameraspace;
	//LightDirection_cameraspace = (viewMatrix*vec4(lightPosition_worldspace,0)).xyz;

    Normal_cameraspace = (viewMatrix * modelMatrix * vec4(normal, 0.0f)).xyz;

	ShadowCoord = DepthBiasMVP * vec4(position,1);
}
